package org.ioc.commons.impl.gwt.client.flowcontrol.placecontroller;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.place.shared.PlaceController.DefaultDelegate;
import com.google.gwt.user.client.Window.ClosingHandler;

public abstract class DelegateAdapter implements GwtPlaceController.Delegate {
	private GwtPlaceController.Delegate defaultDelegate = (GwtPlaceController.Delegate) GWT
			.create(DefaultDelegate.class);

	@Override
	public HandlerRegistration addWindowClosingHandler(ClosingHandler handler) {
		return defaultDelegate.addWindowClosingHandler(handler);
	}

}
