package org.ioc.commons.impl.gwt.client.globalflowcontroller;

import org.ioc.commons.flowcontrol.actioncontroller.ActionHandler;
import org.ioc.commons.flowcontrol.actioncontroller.IsExternalAction;
import org.ioc.commons.flowcontrol.common.BindRegistration;
import org.ioc.commons.flowcontrol.globalflowcontroller.GlobalFlowController.GlobalActionController;
import org.ioc.commons.impl.gwt.client.flowcontrol.actioncontroller.GwtActionControllerImpl;
import org.ioc.commons.ui.IsWidget;

import com.google.web.bindery.event.shared.EventBus;

class GwtGlobalActionControllerImpl<A extends Enum<? extends IsExternalAction>> extends GwtActionControllerImpl<A>
		implements GlobalActionController<A> {

	public GwtGlobalActionControllerImpl(EventBus eventBus) {
		super(eventBus);
		// Nada
	}

	@Override
	public BindRegistration bindAction(IsWidget whileDisplayIsActive, A action, ActionHandler<A> handler) {

		BindRegistration registration = this.bindAction(action, handler);
		
		GwtGlobalFlowController.unbindWhenDetach(registration, whileDisplayIsActive);

		return registration;
	}

}
