package org.ioc.commons.impl.gwt.client.globalflowcontroller;

import org.ioc.commons.flowcontrol.common.BindRegistration;
import org.ioc.commons.flowcontrol.eventbus.EventHandler;
import org.ioc.commons.flowcontrol.eventbus.IsEvent;
import org.ioc.commons.flowcontrol.globalflowcontroller.GlobalFlowController.GlobalEventBus;
import org.ioc.commons.impl.gwt.client.flowcontrol.eventbus.GwtEventBusImpl;
import org.ioc.commons.ui.IsWidget;

import com.google.web.bindery.event.shared.EventBus;

class GwtGlobalEventBusImpl<E extends Enum<? extends IsEvent>> extends GwtEventBusImpl<E> implements GlobalEventBus<E> {

	public GwtGlobalEventBusImpl(EventBus eventBus) {
		super(eventBus);
		// Nada
	}

	@Override
	public BindRegistration bindEvent(IsWidget whileDisplayIsActive, E event, EventHandler<E> handler) {
		BindRegistration registration = this.bindEvent(event, handler);

		GwtGlobalFlowController.unbindWhenDetach(registration, whileDisplayIsActive);

		return registration;
	}

}
