package org.ioc.commons.impl.gwt.integration.client.service.rpc;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.google.gwt.user.client.rpc.RemoteService;

@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface RpcMapping {

	@Target(ElementType.ANNOTATION_TYPE)
	@Retention(RetentionPolicy.RUNTIME)
	public @interface Service {
		Class<? extends org.ioc.commons.integration.service.Service> service();

		Class<? extends RemoteService> rpc();
	}

	Service[] value() default {};
}
