package org.ioc.commons.impl.gwt.client.ui;

import org.ioc.commons.ui.HasVisibility;

public class HasVisibilityWrapper implements HasVisibility {

	private com.google.gwt.user.client.ui.HasVisibility wrapped;

	private HasVisibilityWrapper(com.google.gwt.user.client.ui.HasVisibility wrapped) {
		this.wrapped = wrapped;
	}

	@Override
	public void setVisible(boolean visible) {
		this.wrapped.setVisible(visible);
	}

	@Override
	public boolean isVisible() {
		return this.wrapped.isVisible();
	}

	public static HasVisibility from(com.google.gwt.user.client.ui.HasVisibility gwtHasVisibility) {
		return new HasVisibilityWrapper(gwtHasVisibility);
	}

}
