package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory.rebind.internal;

import com.google.web.bindery.requestfactory.shared.EntityProxyId;

public abstract class RFBaseIdImpl {

	private EntityProxyId<?> entityProxyId;

	public RFBaseIdImpl(EntityProxyId<?> entityProxyId) {
		this.entityProxyId = entityProxyId;
	}

	public EntityProxyId<?> getEntityProxyId() {
		return entityProxyId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((entityProxyId == null) ? 0 : entityProxyId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RFBaseIdImpl other = (RFBaseIdImpl) obj;
		if (entityProxyId == null) {
			if (other.entityProxyId != null)
				return false;
		} else if (!entityProxyId.equals(other.entityProxyId))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return (entityProxyId != null) ? entityProxyId.toString() : super.toString();
	}

}
