package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory.rebind.internal;

import java.util.Map;

import com.google.web.bindery.requestfactory.shared.RequestFactory;

public abstract class RFDaoFactory<F extends RequestFactory> {

	protected final RequestProvider<F> requestProvider;

	protected final Map<String, RequestQueue> queueRequests;

	protected RFDaoFactory(RequestProvider<F> requestProvider, Map<String, RequestQueue> queueRequests) {
		this.requestProvider = requestProvider;
		this.queueRequests = queueRequests;
	}
}
