package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory.rebind.internal;

import org.ioc.commons.integration.dataaccess.dao.IsDaoFactory;

import com.google.web.bindery.requestfactory.shared.RequestFactory;

public abstract class RFNoTxRequestProvider<D extends IsDaoFactory, F extends RequestFactory>  implements RequestProvider<F> {

	protected final F dataFactory;

	public RFNoTxRequestProvider(F dataFactory) {
		this.dataFactory = dataFactory;
	}

	@Override
	public final F getDataFactory() {
		return dataFactory;
	}

	@Override
	public final boolean getAutoFire() {
		return true;
	}

}
